diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/tcp/tcp-bbr-example.cc ns-3.41/examples/tcp/tcp-bbr-example.cc
--- ns-3.40/examples/tcp/tcp-bbr-example.cc	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/tcp/tcp-bbr-example.cc	2024-02-09 14:44:07.837789500 -0800
@@ -60,9 +60,15 @@
 #include "ns3/point-to-point-module.h"
 #include "ns3/traffic-control-module.h"
 
+#include <filesystem>
+
 using namespace ns3;
+using namespace ns3::SystemPath;
 
 std::string dir;
+std::ofstream throughput;
+std::ofstream queueSize;
+
 uint32_t prev = 0;
 Time prevTime = Seconds(0);
 
@@ -71,15 +77,16 @@
 TraceThroughput(Ptr<FlowMonitor> monitor)
 {
     FlowMonitor::FlowStatsContainer stats = monitor->GetFlowStats();
-    auto itr = stats.begin();
-    Time curTime = Now();
-    std::ofstream thr(dir + "/throughput.dat", std::ios::out | std::ios::app);
-    thr << curTime << " "
-        << 8 * (itr->second.txBytes - prev) /
-               (1000 * 1000 * (curTime.GetSeconds() - prevTime.GetSeconds()))
-        << std::endl;
-    prevTime = curTime;
-    prev = itr->second.txBytes;
+    if (!stats.empty())
+    {
+        auto itr = stats.begin();
+        Time curTime = Now();
+        throughput << curTime << " "
+                   << 8 * (itr->second.txBytes - prev) / ((curTime - prevTime).ToDouble(Time::US))
+                   << std::endl;
+        prevTime = curTime;
+        prev = itr->second.txBytes;
+    }
     Simulator::Schedule(Seconds(0.2), &TraceThroughput, monitor);
 }
 
@@ -89,9 +96,7 @@
 {
     uint32_t qsize = qd->GetCurrentSize().GetValue();
     Simulator::Schedule(Seconds(0.2), &CheckQueueSize, qd);
-    std::ofstream q(dir + "/queueSize.dat", std::ios::out | std::ios::app);
-    q << Simulator::Now().GetSeconds() << " " << qsize << std::endl;
-    q.close();
+    queueSize << Simulator::Now().GetSeconds() << " " << qsize << std::endl;
 }
 
 // Trace congestion window
@@ -143,6 +148,10 @@
     queueDisc = std::string("ns3::") + queueDisc;
 
     Config::SetDefault("ns3::TcpL4Protocol::SocketType", StringValue("ns3::" + tcpTypeId));
+
+    // The maximum send buffer size is set to 4194304 bytes (4MB) and the
+    // maximum receive buffer size is set to 6291456 bytes (6MB) in the Linux
+    // kernel. The same buffer sizes are used as default in this example.
     Config::SetDefault("ns3::TcpSocket::SndBufSize", UintegerValue(4194304));
     Config::SetDefault("ns3::TcpSocket::RcvBufSize", UintegerValue(6291456));
     Config::SetDefault("ns3::TcpSocket::InitialCwnd", UintegerValue(10));
@@ -225,23 +234,20 @@
 
     // Create a new directory to store the output of the program
     dir = "bbr-results/" + currentTime + "/";
-    std::string dirToSave = "mkdir -p " + dir;
-    if (system(dirToSave.c_str()) == -1)
-    {
-        exit(1);
-    }
+    MakeDirectories(dir);
 
     // The plotting scripts are provided in the following repository, if needed:
     // https://github.com/mohittahiliani/BBR-Validation/
     //
     // Download 'PlotScripts' directory (which is inside ns-3 scripts directory)
     // from the link given above and place it in the ns-3 root directory.
-    // Uncomment the following three lines to generate plots for Congestion
-    // Window, sender side throughput and queue occupancy on the bottleneck link.
+    // Uncomment the following three lines to copy plot scripts for
+    // Congestion Window, sender side throughput and queue occupancy on the
+    // bottleneck link into the output directory.
     //
-    // system (("cp -R PlotScripts/gnuplotScriptCwnd " + dir).c_str ());
-    // system (("cp -R PlotScripts/gnuplotScriptThroughput " + dir).c_str ());
-    // system (("cp -R PlotScripts/gnuplotScriptQueueSize " + dir).c_str ());
+    // std::filesystem::copy("PlotScripts/gnuplotScriptCwnd", dir);
+    // std::filesystem::copy("PlotScripts/gnuplotScriptThroughput", dir);
+    // std::filesystem::copy("PlotScripts/gnuplotScriptQueueSize", dir);
 
     // Trace the queue occupancy on the second interface of R1
     tch.Uninstall(routers.Get(0)->GetDevice(1));
@@ -252,13 +258,17 @@
     // Generate PCAP traces if it is enabled
     if (enablePcap)
     {
-        if (system((dirToSave + "/pcap/").c_str()) == -1)
-        {
-            exit(1);
-        }
+        MakeDirectories(dir + "pcap/");
         bottleneckLink.EnablePcapAll(dir + "/pcap/bbr", true);
     }
 
+    // Open files for writing throughput traces and queue size
+    throughput.open(dir + "/throughput.dat", std::ios::out);
+    queueSize.open(dir + "/queueSize.dat", std::ios::out);
+
+    NS_ASSERT_MSG(throughput.is_open(), "Throughput file was not opened correctly");
+    NS_ASSERT_MSG(queueSize.is_open(), "Queue size file was not opened correctly");
+
     // Check for dropped packets using Flow Monitor
     FlowMonitorHelper flowmon;
     Ptr<FlowMonitor> monitor = flowmon.InstallAll();
@@ -268,5 +278,8 @@
     Simulator::Run();
     Simulator::Destroy();
 
+    throughput.close();
+    queueSize.close();
+
     return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/tcp/tcp-linux-reno.cc ns-3.41/examples/tcp/tcp-linux-reno.cc
--- ns-3.40/examples/tcp/tcp-linux-reno.cc	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/tcp/tcp-linux-reno.cc	2024-02-09 14:44:07.837789500 -0800
@@ -52,6 +52,9 @@
 Time stopTime = Seconds(60);
 uint32_t segmentSize = 524;
 
+std::ofstream fPlotQueue;
+std::ofstream fPlotCwnd;
+
 // Function to check queue length of Router 1
 void
 CheckQueueSize(Ptr<QueueDisc> queue)
@@ -60,19 +63,14 @@
 
     // Check queue size every 1/100 of a second
     Simulator::Schedule(Seconds(0.001), &CheckQueueSize, queue);
-    std::ofstream fPlotQueue(std::stringstream(dir + "queue-size.dat").str(),
-                             std::ios::out | std::ios::app);
     fPlotQueue << Simulator::Now().GetSeconds() << " " << qSize << std::endl;
-    fPlotQueue.close();
 }
 
 // Function to trace change in cwnd at n0
 static void
 CwndChange(uint32_t oldCwnd, uint32_t newCwnd)
 {
-    std::ofstream fPlotQueue(dir + "cwndTraces/n0.dat", std::ios::out | std::ios::app);
-    fPlotQueue << Simulator::Now().GetSeconds() << " " << newCwnd / segmentSize << std::endl;
-    fPlotQueue.close();
+    fPlotCwnd << Simulator::Now().GetSeconds() << " " << newCwnd / segmentSize << std::endl;
 }
 
 // Function to calculate drops in a particular Queue
@@ -228,15 +226,11 @@
         retVal = system(dirToRemove.c_str());
         NS_ASSERT_MSG(retVal == 0, "Error in return value");
     }
-    std::string dirToSave = "mkdir -p " + dir;
-    retVal = system(dirToSave.c_str());
-    NS_ASSERT_MSG(retVal == 0, "Error in return value");
-    retVal = system((dirToSave + "/pcap/").c_str());
-    NS_ASSERT_MSG(retVal == 0, "Error in return value");
-    retVal = system((dirToSave + "/queueTraces/").c_str());
-    NS_ASSERT_MSG(retVal == 0, "Error in return value");
-    retVal = system((dirToSave + "/cwndTraces/").c_str());
-    NS_ASSERT_MSG(retVal == 0, "Error in return value");
+
+    SystemPath::MakeDirectories(dir);
+    SystemPath::MakeDirectories(dir + "/pcap/");
+    SystemPath::MakeDirectories(dir + "/queueTraces/");
+    SystemPath::MakeDirectories(dir + "/cwndTraces/");
 
     // Set default parameters for queue discipline
     Config::SetDefault(qdiscTypeId + "::MaxSize", QueueSizeValue(QueueSize("100p")));
@@ -251,6 +245,10 @@
     // Enable BQL
     tch.SetQueueLimits("ns3::DynamicQueueLimits");
 
+    // Open files for writing queue size and cwnd traces
+    fPlotQueue.open(dir + "queue-size.dat", std::ios::out);
+    fPlotCwnd.open(dir + "cwndTraces/n0.dat", std::ios::out);
+
     // Calls function to check queue size
     Simulator::ScheduleNow(&CheckQueueSize, qd.Get(0));
 
@@ -299,5 +297,8 @@
 
     Simulator::Destroy();
 
+    fPlotQueue.close();
+    fPlotCwnd.close();
+
     return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/tcp/tcp-validation.cc ns-3.41/examples/tcp/tcp-validation.cc
--- ns-3.40/examples/tcp/tcp-validation.cc	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/tcp/tcp-validation.cc	2024-02-09 14:44:07.837789500 -0800
@@ -663,6 +663,9 @@
     Config::SetDefault("ns3::TcpSocket::InitialCwnd", UintegerValue(10));
     Config::SetDefault("ns3::TcpL4Protocol::RecoveryType",
                        TypeIdValue(TcpPrrRecovery::GetTypeId()));
+    // Validation criteria were written for TCP Cubic without Reno-friendly behavior, so disable it
+    // for these tests
+    Config::SetDefault("ns3::TcpCubic::TcpFriendliness", BooleanValue(false));
 
     ////////////////////////////////////////////////////////////
     // command-line argument parsing                          //
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/tutorial/first.py ns-3.41/examples/tutorial/first.py
--- ns-3.40/examples/tutorial/first.py	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/tutorial/first.py	2024-02-09 14:44:07.841789700 -0800
@@ -1,19 +1,26 @@
-# /*
-#  * This program is free software; you can redistribute it and/or modify
-#  * it under the terms of the GNU General Public License version 2 as
-#  * published by the Free Software Foundation;
-#  *
-#  * This program is distributed in the hope that it will be useful,
-#  * but WITHOUT ANY WARRANTY; without even the implied warranty of
-#  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#  * GNU General Public License for more details.
-#  *
-#  * You should have received a copy of the GNU General Public License
-#  * along with this program; if not, write to the Free Software
-#  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#  */
-
-from ns import ns
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 2 as
+# published by the Free Software Foundation;
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 
 # // Default Network Topology
 # //
@@ -38,8 +45,7 @@
 stack.Install(nodes)
 
 address = ns.internet.Ipv4AddressHelper()
-address.SetBase(ns.network.Ipv4Address("10.1.1.0"),
-                ns.network.Ipv4Mask("255.255.255.0"))
+address.SetBase(ns.network.Ipv4Address("10.1.1.0"), ns.network.Ipv4Mask("255.255.255.0"))
 
 interfaces = address.Assign(devices)
 
@@ -61,4 +67,3 @@
 
 ns.core.Simulator.Run()
 ns.core.Simulator.Destroy()
-
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/tutorial/second.py ns-3.41/examples/tutorial/second.py
--- ns-3.40/examples/tutorial/second.py	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/tutorial/second.py	2024-02-09 14:44:07.841789700 -0800
@@ -1,23 +1,30 @@
-# -*-  Mode: Python; -*-
-# /*
-#  * This program is free software; you can redistribute it and/or modify
-#  * it under the terms of the GNU General Public License version 2 as
-#  * published by the Free Software Foundation;
-#  *
-#  * This program is distributed in the hope that it will be useful,
-#  * but WITHOUT ANY WARRANTY; without even the implied warranty of
-#  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#  * GNU General Public License for more details.
-#  *
-#  * You should have received a copy of the GNU General Public License
-#  * along with this program; if not, write to the Free Software
-#  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#  *
-#  * Ported to Python by Mohit P. Tahiliani
-#  */
-
-from ns import ns
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 2 as
+# published by the Free Software Foundation;
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+# Ported to Python by Mohit P. Tahiliani
+#
+
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 import sys
+from ctypes import c_bool, c_int
 
 # // Default Network Topology
 # //
@@ -27,7 +34,7 @@
 # //                    ================
 # //                      LAN 10.1.2.0
 
-from ctypes import c_int, c_bool
+
 nCsma = c_int(3)
 verbose = c_bool(True)
 cmd = ns.CommandLine(__file__)
@@ -76,9 +83,11 @@
 serverApps.Start(ns.core.Seconds(1.0))
 serverApps.Stop(ns.core.Seconds(10.0))
 
-echoClient = ns.applications.UdpEchoClientHelper(csmaInterfaces.GetAddress(nCsma.value).ConvertTo(), 9)
+echoClient = ns.applications.UdpEchoClientHelper(
+    csmaInterfaces.GetAddress(nCsma.value).ConvertTo(), 9
+)
 echoClient.SetAttribute("MaxPackets", ns.core.UintegerValue(1))
-echoClient.SetAttribute("Interval", ns.core.TimeValue(ns.core.Seconds (1.0)))
+echoClient.SetAttribute("Interval", ns.core.TimeValue(ns.core.Seconds(1.0)))
 echoClient.SetAttribute("PacketSize", ns.core.UintegerValue(1024))
 
 clientApps = echoClient.Install(p2pNodes.Get(0))
@@ -88,8 +97,7 @@
 ns.internet.Ipv4GlobalRoutingHelper.PopulateRoutingTables()
 
 pointToPoint.EnablePcapAll("second")
-csma.EnablePcap ("second", csmaDevices.Get (1), True)
+csma.EnablePcap("second", csmaDevices.Get(1), True)
 
 ns.core.Simulator.Run()
 ns.core.Simulator.Destroy()
-
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/examples/tutorial/third.py ns-3.41/examples/tutorial/third.py
--- ns-3.40/examples/tutorial/third.py	2023-09-27 13:30:37.606839000 -0700
+++ ns-3.41/examples/tutorial/third.py	2024-02-09 14:44:07.841789700 -0800
@@ -1,23 +1,30 @@
-# -*-  Mode: Python; -*-
-# /*
-#  * This program is free software; you can redistribute it and/or modify
-#  * it under the terms of the GNU General Public License version 2 as
-#  * published by the Free Software Foundation;
-#  *
-#  * This program is distributed in the hope that it will be useful,
-#  * but WITHOUT ANY WARRANTY; without even the implied warranty of
-#  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#  * GNU General Public License for more details.
-#  *
-#  * You should have received a copy of the GNU General Public License
-#  * along with this program; if not, write to the Free Software
-#  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#  *
-#  * Ported to Python by Mohit P. Tahiliani
-#  */
-
-from ns import ns
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 2 as
+# published by the Free Software Foundation;
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+# Ported to Python by Mohit P. Tahiliani
+#
+
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 import sys
+from ctypes import c_bool, c_int
 
 # // Default Network Topology
 # //
@@ -30,7 +37,7 @@
 # //                                   ================
 # //                                     LAN 10.1.2.0
 
-from ctypes import c_bool, c_int
+
 nCsma = c_int(3)
 verbose = c_bool(True)
 nWifi = c_int(3)
@@ -83,22 +90,40 @@
 phy.SetChannel(channel.Create())
 
 mac = ns.wifi.WifiMacHelper()
-ssid = ns.wifi.Ssid ("ns-3-ssid")
+ssid = ns.wifi.Ssid("ns-3-ssid")
 
 wifi = ns.wifi.WifiHelper()
 
-mac.SetType ("ns3::StaWifiMac", "Ssid", ns.wifi.SsidValue(ssid), "ActiveProbing", ns.core.BooleanValue(False))
+mac.SetType(
+    "ns3::StaWifiMac", "Ssid", ns.wifi.SsidValue(ssid), "ActiveProbing", ns.core.BooleanValue(False)
+)
 staDevices = wifi.Install(phy, mac, wifiStaNodes)
 
-mac.SetType("ns3::ApWifiMac","Ssid", ns.wifi.SsidValue (ssid))
+mac.SetType("ns3::ApWifiMac", "Ssid", ns.wifi.SsidValue(ssid))
 apDevices = wifi.Install(phy, mac, wifiApNode)
 
 mobility = ns.mobility.MobilityHelper()
-mobility.SetPositionAllocator("ns3::GridPositionAllocator", "MinX", ns.core.DoubleValue(0.0),
-                              "MinY", ns.core.DoubleValue (0.0), "DeltaX", ns.core.DoubleValue(5.0), "DeltaY", ns.core.DoubleValue(10.0),
-                              "GridWidth", ns.core.UintegerValue(3), "LayoutType", ns.core.StringValue("RowFirst"))
-
-mobility.SetMobilityModel ("ns3::RandomWalk2dMobilityModel", "Bounds", ns.mobility.RectangleValue(ns.mobility.Rectangle (-50, 50, -50, 50)))
+mobility.SetPositionAllocator(
+    "ns3::GridPositionAllocator",
+    "MinX",
+    ns.core.DoubleValue(0.0),
+    "MinY",
+    ns.core.DoubleValue(0.0),
+    "DeltaX",
+    ns.core.DoubleValue(5.0),
+    "DeltaY",
+    ns.core.DoubleValue(10.0),
+    "GridWidth",
+    ns.core.UintegerValue(3),
+    "LayoutType",
+    ns.core.StringValue("RowFirst"),
+)
+
+mobility.SetMobilityModel(
+    "ns3::RandomWalk2dMobilityModel",
+    "Bounds",
+    ns.mobility.RectangleValue(ns.mobility.Rectangle(-50, 50, -50, 50)),
+)
 mobility.Install(wifiStaNodes)
 
 mobility.SetMobilityModel("ns3::ConstantPositionMobilityModel")
@@ -126,12 +151,14 @@
 serverApps.Start(ns.core.Seconds(1.0))
 serverApps.Stop(ns.core.Seconds(10.0))
 
-echoClient = ns.applications.UdpEchoClientHelper(csmaInterfaces.GetAddress(nCsma.value).ConvertTo(), 9)
+echoClient = ns.applications.UdpEchoClientHelper(
+    csmaInterfaces.GetAddress(nCsma.value).ConvertTo(), 9
+)
 echoClient.SetAttribute("MaxPackets", ns.core.UintegerValue(1))
-echoClient.SetAttribute("Interval", ns.core.TimeValue(ns.core.Seconds (1.0)))
+echoClient.SetAttribute("Interval", ns.core.TimeValue(ns.core.Seconds(1.0)))
 echoClient.SetAttribute("PacketSize", ns.core.UintegerValue(1024))
 
-clientApps = echoClient.Install(wifiStaNodes.Get (nWifi.value - 1))
+clientApps = echoClient.Install(wifiStaNodes.Get(nWifi.value - 1))
 clientApps.Start(ns.core.Seconds(2.0))
 clientApps.Stop(ns.core.Seconds(10.0))
 
@@ -141,10 +168,9 @@
 
 if tracing.value:
     phy.SetPcapDataLinkType(phy.DLT_IEEE802_11_RADIO)
-    pointToPoint.EnablePcapAll ("third")
-    phy.EnablePcap ("third", apDevices.Get (0))
-    csma.EnablePcap ("third", csmaDevices.Get (0), True)
+    pointToPoint.EnablePcapAll("third")
+    phy.EnablePcap("third", apDevices.Get(0))
+    csma.EnablePcap("third", csmaDevices.Get(0), True)
 
 ns.core.Simulator.Run()
 ns.core.Simulator.Destroy()
-
